/**
 * @(#)ClusterObj.java  12/12/99
 * @author Peter Au
 * All rights reserved.
 */

package vishnu.testvis.object;
import vishnu.datablock.*;
import java.util.Vector;

public class ClusterObj
{
    DocObj[] _docs;		//-- list of DocObj ref
    String _label;		//-- (top 3-5? related words)
    Point2D [] _sammon;			//-- 2D mapping for the centroids
    DataManager _data;
    public ClusterObj(DocObj[] d, String t, Point2D [] sammon, DataManager dm)
    {
        _docs=d; _label=t;
        _sammon = sammon;
        _data = dm;
    }
  /**
   * @return the number of documents in the cluster
   */
  public int getDocsSize(){return _docs.length;}

  public String getLabel(){return _label;}

  public String getLabel1(){return getDocsSize() + " documents found";}
  public String getLabel2(){return getLabel();}


  public String getInfo(){
    return getDocsSize() + " documents found\n" + getLabel();
  }


  /**
   * This returns a list of list of documents. The inner list of documents represents
   * which documents have the corresponding related word
   * pre: _docs can't be null
   * @return a vector (same length as the related words) of
   *         vectors (arbitrary length)
   *
   */
  public Vector getHitDocFreq()
  {
    int s = _data.getWordCount();
    Vector rwVec = new Vector(s);
    for(int i=0;i<s;i++)
    {
      rwVec.addElement(new Vector(0));
      for(int j=0;j<_docs.length;j++)
      {
        if ( _docs[j].getWeights(i) > 0 )
          ((Vector) rwVec.elementAt(i)).addElement(_docs[j]);
      }
    }
    return rwVec;
  }


  public String formatDocs()
  {
    int l = getDocsSize();
    String s = "<html><font face=Arial size=-1> "+ l +" documents found\n";
    for(int i=0;i<l;i++)
    {
      s += _docs[i].format4Fields();
    }
    s += "</font></html>\n";
    return s;
  }


}
